"use strict";
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _Notifier_subscribers;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Notifier = void 0;
class Notifier {
    constructor() {
        _Notifier_subscribers.set(this, {});
    }
    add(event, handler) {
        if (!event) {
            throw new TypeError("Event can't be null");
        }
        if (!handler || typeof handler !== "function") {
            throw new Error("Callback needs to be a valid function");
        }
        if (!__classPrivateFieldGet(this, _Notifier_subscribers, "f")[event]) {
            __classPrivateFieldGet(this, _Notifier_subscribers, "f")[event] = [];
        }
        __classPrivateFieldGet(this, _Notifier_subscribers, "f")[event].push(handler);
    }
    remove(event, handler) {
        if (!event) {
            throw new TypeError("Event can't be null");
        }
        if (!handler || typeof handler !== "function") {
            throw new Error("Callback needs to be a valid function");
        }
        if (!__classPrivateFieldGet(this, _Notifier_subscribers, "f")[event]) {
            __classPrivateFieldGet(this, _Notifier_subscribers, "f")[event] = [];
        }
        let index = __classPrivateFieldGet(this, _Notifier_subscribers, "f")[event].findIndex(element => element === handler);
        if (index !== -1) {
            __classPrivateFieldGet(this, _Notifier_subscribers, "f")[event].splice(index, 1);
        }
    }
    notify(event, msg) {
        if (__classPrivateFieldGet(this, _Notifier_subscribers, "f")[event]) {
            for (const subscriber of __classPrivateFieldGet(this, _Notifier_subscribers, "f")[event]) {
                subscriber(msg);
            }
        }
    }
    ;
    clear() {
        __classPrivateFieldSet(this, _Notifier_subscribers, {}, "f");
    }
}
exports.Notifier = Notifier;
_Notifier_subscribers = new WeakMap();
//# sourceMappingURL=notifier.js.map